from bs4 import BeautifulSoup
import requests
import time

from beautifulsoup.parameters import parameters


class html_tools(object):
    def __init__(self):
        pass

    def get_driver_id(self,html_doc):
        ids = []
        bsp = BeautifulSoup(html_doc, 'html.parser',from_encoding="iso-8859-1")
        datas = bsp.find_all('a')
        datas = filter(lambda x:x != None,[ele.get('href') for ele in datas])
        for e in datas:
            start = e.find("'")
            end = e.find("'", start + 1)
            id = e[start + 1:end]
            ids.append(id)
        return ids
    #获取当前页面总页数
    def total_page(self,html_doc):
        bsp = BeautifulSoup(html_doc, 'html.parser',from_encoding="iso-8859-1")
        def is_page(div):
            classes = div.get('class')
            if classes == ['rit', 'mar10']: return True
            else: return False

        divs = bsp.find_all('div')
        div = filter(is_page, divs)
        div_label = str(list(div)[0])
        start_index = div_label.find('录 共')
        if start_index == -1:
            return 1
        end_index = div_label.find('页 转')
        print('start_index:',start_index)
        print('end_index:', end_index)
        return int(div_label[start_index + 3:end_index])


    def get_data(self,html_doc):
        # datas = {}
        data_list = []
        bsp = BeautifulSoup(html_doc, 'html.parser',from_encoding="iso-8859-1")
        tab = bsp.table #获取第一个table
        # print(tab)
        rows = tab.find_all('tr') #获取每一行数据
        for row in rows:
            tds = row.find_all('td')
            tds = filter(lambda td: td.get('class') is None, tds)
            for td in tds:
                text = td.get_text()
                text = text.replace('\r','').replace('\n','').replace('\t','').replace(' ','').replace('\xa0','')
                data_list.append(text)
        return data_list

    def retry(self,url,parameter):
        global res
        id_html_doc = requests.get(url, headers=parameter.create_id_header()).content
        try:
            res = self.get_data(id_html_doc)
        except Exception:
            # time.sleep(1)
            self.retry(url,parameter)
        return res

if __name__ == '__main__':


    def is_page(div):
        classes = div.get('class')
        if classes == ['rit', 'mar10']: return True
        else: return False
    parameter = parameters()
    html_doc = requests.post(parameter.driver_url,data=parameter.create_one_page_parameter(),  headers=parameter.create_one_page_header()).content
    bsp = BeautifulSoup(html_doc, 'html.parser')
    divs = bsp.find_all('div')
    # classes = [ele.get('class') for ele in divs]
    # print(classes)
    div = filter(is_page, divs)
    # div = filter(lambda x: x == ['rit', 'mar10'], [ele.get('class') for ele in divs])
    div_label = str(list(div)[0])
    index = div_label.find('页 转')
    print(index)
    print(div_label[987:989])
    # a = [1,2,3,4]
    # b = filter(lambda x:x > 2,a)
    # for i in b:
    #     print(i)




